package com.objis.demohibernate.servlets;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.stat.Statistics;

public class Controleur extends HttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		
		Session session = getSession();

		closeSession(session);
		
		resp.setContentType("text/html");
		PrintWriter out = resp.getWriter();
		out.println("<HTML>");
		out.println("<HEADER><TITLE>Ouverture / Fermeture de la Session Hibernate dans le controleur</TITLE></HEADER>");
		out.println("<BODY>");
		out.println("<h1>Manipulation Session Hibernate : Technique N1 (Servlet d'initialisation)</h1>");
		out.println("<a href='http://www.objis.com/formation-java/formation-framework-java-hibernate.html'><img border=0 align='right' src='http://www.objis.com/formation-java/IMG/png/promo-formation-hibernate-objis.png' ALT='Votre formation HIBERNATE avec Objis, spcialiste formation java depuis 2005' title ='Votre formation HIBERNATE avec Objis, spcialiste formation java depuis 2005'/></a>");
		out.println("a y est ! Vous avez effectu un cycle de rcupration / utilisation / fermeture d'une Session hibernate grace  la SessionFactory prsente dans le contexte de Servlet");
		out.println("<p>Nous avons trac les statistiques hibernate aprs chaque fermeture de Session Hibernate");
		out.println("<p>Analysez les Statistiques de la Session hibernate dans les logs aprs chaque <a href='test'>sollicitation du Controleur</a>.");
		out.println("<p> 2 constats <ul><li>le nb de d'objets session utilis incrmente</li> <li> Il y a exactement le mme nb d'objets Session ouvert que ferm</li></ul>");
		out.println("INCONVENIENT : vous devez fermer la session hibernate ' la main' aprs chaque utilisation. <p>Cette technique est  recommander pour de petits projets. Meilleure pratique : Session local au thread !");		
		out.println("<p>MEILLEURE PRATIQUE (Voir technique N2): Mettre en oeuvre un <b>filtre Http</b>  -  utiliser si vous n'avez pas de frameworks de vue type struts / Webwork");		
		out.println("<p>MEILLEURE PRATIQUE (Voir technique N3): Mettre en oeuvre une <b>Couche de service + Dlgation vers couche DAO et autres classes (ex : comparateur)<b>   ");		
		out.println("<p>Le chemin le plus court pour avoir les rflexes et la mthode du bon dveloppeur HIBERNATE : <a href='http://www.objis.com/formation-java/formation-framework-java-hibernate.html'>Formation Hibernate OBJIS</a> !");

			
		out.println("</BODY>");
		out.println("</HTML>");
		out.close();
		
	}
	
	/**
	 * Obtenir une Session
	 */
	public Session getSession() {
		Session session = null;
		SessionFactory f = (SessionFactory) getServletContext().getAttribute("session.factory");
		try {
			session = f.openSession();
		} catch (HibernateException e) {
			e.printStackTrace();
		}
		return session;
	}

	/**
	 * Fermer une Session
	 */
	public void closeSession(Session session) {
		try {
			session.close();
			SessionFactory f = (SessionFactory) getServletContext().getAttribute("session.factory");
			Statistics stats = f.getStatistics();
			stats.logSummary();
		} catch (HibernateException e) {
			e.printStackTrace();
		}
	}


}
