package com.objis.demohibernate.servlets;

import java.io.IOException;

import javax.servlet.GenericServlet;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;

import com.objis.demohibernate.util.HibernateUtil;

/**
 * Scnario 1 de rcupration d'une session en environnement web : 
 * utiliser une servlet d'initialisation.
 * 
 * PROBLEMATIQUE 1 : rcuprer la Session hibernate  partir de la SessionFactory
 * PROBLEMATIQUE 2 : fermer la Session hibernate une fois le travail mtier termin 
 * CAS D'UTILISATION : 
 * --> Application simple (moins de 10 objets mtiers) 
 * --> Choix accs direct  la session par le controleur
 * ARCHITECTURE : Pas de couche service. Pas design pattern business delegate)
 * INCONVENIENT : vous devez fermer la session hibernate ' la main'.
 */
public class SessionFactoryInitServlet extends GenericServlet {

	public void init(ServletConfig config) throws ServletException {

		// Cration d'une SessionFactory  l'initialisation de la servlet
		super.init(config);
		SessionFactory f = null;
		try {
			f = HibernateUtil.getSessionFactory();
		} catch (HibernateException e) {
			e.printStackTrace();
		}
		// insre la SessionFactory dans le contexte de Servlets (cl=valeur)
		// Une autre servlet pourra donc la rcuprer pour crer Session hibernate
		getServletContext().setAttribute("session.factory", f);
	}

	public void service(ServletRequest arg0, ServletResponse arg1)
			throws ServletException, IOException {
		// TODO Auto-generated method stub

	}

	private static final long serialVersionUID = 1L;

}
